#ifndef __l4_rdtsc_h
#define __l4_rdtsc_h

typedef union tcs_value
{
    long long ll;
    struct {
	long	lo;
	long	hi;
    } lh;
} tsc_value_t;


static inline tsc_value_t 
l4_rdtsc(void)
{
    tsc_value_t v;
    
    __asm__ __volatile__ (
			".byte 0x0f, 0x31\n\t"
			/*"rdtsc\n\t"*/           /* .byte 0x0f, 0x31 */
			: "=a" (v.lh.lo),  /* EAX, 0 */
			"=d" (v.lh.hi)   /* EDX, 1 */
			: /* no inputs */
			: "eax", "edx"
	);
    
    return v;
}

#endif /* __l4_rdtsc_h */
