/* -*- c -*- */

/* this file defines the construction of the kernel's virtual address
   space */

_tcbs_1     = 0xc0000000;	/* assumption: 256MB-aligned */
_mappings_1 = 0xe0000000;
_mappings_end_1 = 0xea000000;	/* XXX old code uses _unused1_1 as
				   end-of-region */
_unused1_1  = _mappings_end_1;	/* assumption: 4MB-aligned */
_unused2_1  = 0xea400000;	/* assumption: 4MB-aligned */
_unused3_1  = 0xea800000;	/* assumption: 4MB-aligned */
/* 0xeac00000 - 0xee000000 unused */
_ipc_window0_1 = 0xee000000;	/* assumption: 8MB-aligned */
_ipc_window1_1 = 0xee800000;	/* assumption: 8MB-aligned */
/* 0xef000000 - 0xef800000 unused */
_kstatic1_1 = 0xef800000;	/* assumption: 4MB-aligned */
_iobitmap_1 = 0xefc00000;	/* assumption: 4MB-aligned */
_physmem_1  = 0xf0000000;	/* assumption: 256MB-aligned */

load_address = 0x1000;

ENTRY(_start)

SECTIONS {
  . = _physmem_1 + load_address;

  .text : {
    *(.init .text .gnu.linkonce.t* .fini .rodata 
      .gnu.linkonce.r* .data .gnu.linkonce.d* .anno .ctors .dtors)
    CONSTRUCTORS

    . = ALIGN(0x1000);

    _edata  =  .;
    *(.bss COMMON)
  }

  _end = . ;
}
