// -*- c++ -*-

#ifndef KMEM_SLAB_H
#define KMEM_SLAB_H

#include <stddef.h>
#include "libk/slab.h"
#include "lock.h"

class kmem_slab_t : public slab_cache_anon
{
public:
  kmem_slab_t(unsigned long slab_size, unsigned elem_size, 
	      unsigned alignment);
  virtual ~kmem_slab_t();

  virtual void *alloc();	// request initialized member from cache
  virtual void free(void *cache_entry);	// return initialized member to cache
  virtual bool reap();

  void *operator new(size_t size);
  void operator delete(void *block, size_t size);

private:
  virtual void *block_alloc(unsigned long size, unsigned long alignment);
  virtual void block_free(void *block, unsigned long size);

  // implementation-specific data representation follows
  helping_lock_t _lock;
};

#endif
